diff -r ba8a9d2934c7 -r fa85bd7065f3 libinterp/corefcn/eig.cc
--- a/libinterp/corefcn/eig.cc	Mon Jul 18 13:52:57 2016 +0200
+++ b/libinterp/corefcn/eig.cc	Wed Jul 20 19:14:57 2016 +0200
@@ -222,76 +378,748 @@ The eigenvalues returned by @code{eig} a
 %! assert (v, [-x, x; x, x], sqrt (eps ("single")));
 
 %!test
+%! [v, d, w] = eig (single ([1, 2; 2, 1]));
+%! x = single (1 / sqrt (2));
+%! assert (w, [-x, x; x, x], sqrt (eps ("single")));
+
+%!test
+%! [v, d] = eig (single ([1, 2; 2, 1]), "balance");
+%! x = single (1 / sqrt (2));
+%! assert (d, single ([-1, 0; 0, 3]), sqrt (eps ("single")));
+%! assert (v, [-x, x; x, x], sqrt (eps ("single")));
+
+%!test
+%! [v, d, w] = eig (single ([1, 2; 2, 1]), "balance");
+%! x = single (1 / sqrt (2));
+%! assert (w, [-x, x; x, x], sqrt (eps ("single")));
+
+%!test
 %! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, "qz");
+%! [v3, d3] = eig (A, B, "chol");
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps));
+%! assert (v, v2);
+%! assert (v, v3);
+%! assert (d, d2);
+%! assert (d, d3);
+
+%!test
+%! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, "qz");
+%! [v3, d3, w3] = eig (A, B, "chol");
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps));
+%! assert (v, v2);
+%! assert (v, v3);
+%! assert (d, d2);
+%! assert (d, d3);
+%! assert (w, w2);
+%! assert (w, w3);
 
 %!test
 %! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, "qz");
+%! [v3, d3] = eig (A, B, "chol");
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps ("single")));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (v, v3);
+%! assert (d, d2);
+%! assert (d, d3);
+
+%!test
+%! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, "qz");
+%! [v3, d3, w3] = eig (A, B, "chol");
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps ("single")));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (v, v3);
+%! assert (d, d2);
+%! assert (d, d3);
+%! assert (w, w2);
+%! assert (w, w3);
 
 %!test
 %! A = [1, 2; 2, 1];  B = [3, -2; -2, 3];
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, "chol");
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+
+%!test
+%! A = [1, 2; 2, 1];  B = [3, -2; -2, 3];
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, "chol");
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
 
 %!test
 %! A = single ([1, 2; 2, 1]);  B = single ([3, -2; -2, 3]);
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, "chol");
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps ("single")));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+
+%!test
+%! A = single ([1, 2; 2, 1]);  B = single ([3, -2; -2, 3]);
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, "chol");
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps ("single")));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
 
 %!test
 %! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, "chol");
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+
+%!test
+%! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, "chol");
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
 
 %!test
 %! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, "chol");
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps ("single")));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+
+%!test
+%! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, "chol");
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps ("single")));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
 
 %!test
 %! A = [1+3i, 2+3i; 3-8i, 8+3i];  B = [8+i, 3+i; 4-9i, 3+i];
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, "qz");
+%! [v3, d3] = eig (A, B, "chol");
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (v, v3);
+%! assert (d, d3);
+
+%!test
+%! A = [1+3i, 2+3i; 3-8i, 8+3i];  B = [8+i, 3+i; 4-9i, 3+i];
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, "qz");
+%! [v3, d3, w3] = eig (A, B, "chol");
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+%! assert (v, v3);
+%! assert (d, d3);
+%! assert (w, w3);
 
 %!test
 %! A = single ([1+3i, 2+3i; 3-8i, 8+3i]);  B = single ([8+i, 3+i; 4-9i, 3+i]);
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, "qz");
+%! [v3, d3] = eig (A, B, "chol");
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps ("single")));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (v, v3);
+%! assert (d, d3);
+
+%!test
+%! A = single ([1+3i, 2+3i; 3-8i, 8+3i]);  B = single ([8+i, 3+i; 4-9i, 3+i]);
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, "qz");
+%! [v3, d3, w3] = eig (A, B, "chol");
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps ("single")));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+%! assert (v, v3);
+%! assert (d, d3);
+%! assert (w, w3);
 
 %!test
 %! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, "qz");
+%! [v3, d3] = eig (A, B, "chol");
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (v, v3);
+%! assert (d, d3);
+
+%!test
+%! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, "qz");
+%! [v3, d3, w3] = eig (A, B, "chol");
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+%! assert (v, v3);
+%! assert (d, d3);
+%! assert (w, w3);
 
 %!test
 %! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, "chol");
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+
+%!test
+%! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, "chol");
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
 
 %!test
 %! A = single ([1, 1+i; 1-i, 1]);  B = single ([2, 0; 0, 2]);
 %! [v, d] = eig (A, B);
+%! [v2, d2] = eig (A, B, "chol");
 %! assert (A * v(:, 1), d(1, 1) * B * v(:, 1), sqrt (eps ("single")));
 %! assert (A * v(:, 2), d(2, 2) * B * v(:, 2), sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+
+%!test
+%! A = single ([1, 1+i; 1-i, 1]);  B = single ([2, 0; 0, 2]);
+%! [v, d, w] = eig (A, B);
+%! [v2, d2, w2] = eig (A, B, "chol");
+%! wt = w';
+%! assert (wt(1, :)* A, d(1, 1) * wt(1, :) * B, sqrt (eps ("single")));
+%! assert (wt(2, :)* A, d(2, 2) * wt(2, :) * B, sqrt (eps ("single")));
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [3 -2 -0.9 0; -2 4 1 -0; -0 0 -1 0; -0.5 -0.5 0.1 1];
+%! [V1, D1] = eig (A);
+%! [V2, D2] = eig (A, "balance");
+%! [V3, D3] = eig (A, "nobalance");
+%! assert (V1, V2);
+%! assert (D1, D2);
+%! assert (isequal (V2, V3), false);
+
+%!test
+%! A = diag([10^-16, 10^-15]);
+%! [V1,D1] = eig(A,A);
+%! [V2,D2] = eig(A,A,"qz");
+%! [V3,D3] = eig(A,A,"chol");
+%! assert (V1, V3);
+%! assert (D1, D3);
+%! assert (isequal (V1, V2), false);
+
+%!test
+%! A = [1, 2; 2, 1];
+%! d = eig (A);
+%! assert (isvector(d), true);
+%! d2 = eig (A, "vector");
+%! assert (isvector(d2), true);
+%! [v, d3] = eig (A);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, "matrix");
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = [1, 2; 2, 1];
+%! [v, d, w] = eig (A, "balance", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, "vector", "balance");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; 2, 1];
+%! [v, d, w] = eig (A, "balance", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, "matrix", "balance");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; 2, 1];
+%! [v, d, w] = eig (A, "nobalance", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, "matrix", "nobalance");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; 2, 1];
+%! [v, d, w] = eig (A, "nobalance", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, "vector", "nobalance");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; 2, 1]);
+%! d = eig (A);
+%! assert (isvector(d), true);
+%! d2 = eig (A, "vector");
+%! assert (isvector(d2), true);
+%! [v, d3] = eig (A);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, "matrix");
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = single ([1, 2; 2, 1]);
+%! [v, d, w] = eig (A, "balance", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, "vector", "balance");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; 2, 1]);
+%! [v, d, w] = eig (A, "balance", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, "matrix", "balance");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; 2, 1]);
+%! [v, d, w] = eig (A, "nobalance", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, "matrix", "nobalance");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; 2, 1]);
+%! [v, d, w] = eig (A, "nobalance", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, "vector", "nobalance");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
+%! d = eig (A, B);
+%! assert (isvector(d), true);
+%! d2 = eig (A, B, "vector");
+%! assert (isvector(d2), true);
+%! [v, d3] = eig (A, B);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, B, "matrix");
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
+%! [v, d, w] = eig (A, B, "qz", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, B, "vector", "qz");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
+%! [v, d, w] = eig (A, B, "qz", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, "matrix", "qz");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
+%! [v, d, w] = eig (A, B, "chol", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, "matrix", "chol");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; -1, 1];  B = [3, 3; 1, 2];
+%! [v, d, w] = eig (A, B, "chol", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, B, "vector", "chol");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
+%! d = eig (A, B);
+%! assert (isvector(d), true);
+%! d2 = eig (A, B, "vector");
+%! assert (isvector(d2), true);
+%! [v, d3] = eig (A, B);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, B, "matrix");
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
+%! [v, d, w] = eig (A, B, "qz", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, B, "vector", "qz");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
+%! [v, d, w] = eig (A, B, "qz", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, "matrix", "qz");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
+%! [v, d, w] = eig (A, B, "chol", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, "matrix", "chol");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1, 2; -1, 1]);  B = single ([3, 3; 1, 2]);
+%! [v, d, w] = eig (A, B, "chol", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, B, "vector", "chol");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
+%! d = eig (A, B);
+%! assert (isvector(d), true);
+%! d2 = eig (A, B, "vector");
+%! assert (isvector(d2), true);
+%! [v, d3] = eig (A, B);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, B, "matrix");
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
+%! [v, d, w] = eig (A, B, "qz", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, B, "vector", "qz");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
+%! [v, d, w] = eig (A, B, "qz", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, "matrix", "qz");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
+%! [v, d, w] = eig (A, B, "chol", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, "matrix", "chol");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1+3i, 2+i; 2-i, 1+3i];  B = [5+9i, 2+i; 2-i, 5+9i];
+%! [v, d, w] = eig (A, B, "chol", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, B, "vector", "chol");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
+%! d = eig (A, B);
+%! assert (isvector(d), true);
+%! d2 = eig (A, B, "vector");
+%! assert (isvector(d2), true);
+%! [v, d3] = eig (A, B);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, B, "matrix");
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
+%! [v, d, w] = eig (A, B, "qz", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, B, "vector", "qz");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
+%! [v, d, w] = eig (A, B, "qz", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, "matrix", "qz");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
+%! [v, d, w] = eig (A, B, "chol", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, "matrix", "chol");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = single ([1+3i, 2+i; 2-i, 1+3i]);  B = single ([5+9i, 2+i; 2-i, 5+9i]);
+%! [v, d, w] = eig (A, B, "chol", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, B, "vector", "chol");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
+%! d = eig (A, B);
+%! assert (isvector(d), true);
+%! d2 = eig (A, B, "vector");
+%! assert (isvector(d2), true);
+%! [v, d3] = eig (A, B);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, B, "matrix");
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
+%! [v, d, w] = eig (A, B, "qz", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, B, "vector", "qz");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+
+%!test
+%! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
+%! [v, d, w] = eig (A, B, "qz", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, "matrix", "qz");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
+%! [v, d, w] = eig (A, B, "chol", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, "matrix", "chol");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 2; 3, 8];  B = [8, 3; 4, 3];
+%! [v, d, w] = eig (A, B, "chol", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, B, "vector", "chol");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
+%! d = eig (A, B);
+%! assert (isvector(d), true);
+%! d2 = eig (A, B, "vector");
+%! assert (isvector(d2), true);
+%! [v, d3] = eig (A, B);
+%! assert (isdiag(d3), true);
+%! d4 = eig (A, B, "matrix");
+%! assert (isdiag(d4), true);
+%! assert (d, d2);
+%! assert (d3, d4);
+%! assert (d, diag(d3));
+
+%!test
+%! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
+%! [v, d, w] = eig (A, B, "qz", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, B, "vector", "qz");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
+%! [v, d, w] = eig (A, B, "qz", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, "matrix", "qz");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
+%! [v, d, w] = eig (A, B, "chol", "matrix");
+%! assert (isdiag(d), true);
+%! [v2, d2, w2] = eig (A, B, "matrix", "chol");
+%! assert (isdiag(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
+
+%!test
+%! A = [1, 1+i; 1-i, 1];  B = [2, 0; 0, 2];
+%! [v, d, w] = eig (A, B, "chol", "vector");
+%! assert (isvector(d), true);
+%! [v2, d2, w2] = eig (A, B, "vector", "chol");
+%! assert (isvector(d2), true);
+%! assert (v, v2);
+%! assert (d, d2);
+%! assert (w, w2);
 
 %!error eig ()
+%!error eig (false)
 %!error eig ([1, 2; 3, 4], [4, 3; 2, 1], 1)
 %!error <EIG requires same size matrices> eig ([1, 2; 3, 4], 2)
 %!error <must be a square matrix> eig ([1, 2; 3, 4; 5, 6])
 %!error <wrong type argument> eig ("abcd")
-%!error <wrong type argument> eig ([1 2 ; 2 3], "abcd")
+%!error <eig: unexpected second input: abcd> eig ([1 2 ; 2 3], "abcd")
+%!error <eig: unexpected second input: chol> eig ([1 2 ; 2 3], "chol")
+%!error <eig: unexpected second input: qz> eig ([1 2 ; 2 3], "qz")
 %!error <wrong type argument> eig (false, [1 2 ; 2 3])
+%!error <eig: unexpected third input: abcd> eig ([1 2 ; 2 3], [1 2 ; 2 3], "abcd")
+%!error <eig: unexpected third input: qz> eig ([1 2 ; 2 3], "balance", "qz")
+%!error <eig: unexpected fourth input: abcd> eig ([1 2 ; 2 3], [1 2 ; 2 3], "vector", "abcd")
+%!error <eig: unexpected fourth input: abcd> eig ([1 2 ; 2 3], "balance", "matrix", "abcd")
+%!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], "balance", "nobalance")
+%!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], "nobalance", "balance")
+%!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], "matrix", "vector")
+%!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], "vector", "matrix")
+%!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], [1 2 ; 2 3], "matrix", "vector")
+%!error <eig: the combination of flags is invalid.> eig ([1 2 ; 2 3], [1 2 ; 2 3], "vector", "matrix")
+%!error <wrong type argument> eig ([1 2 ; 2 3], [1 2 ; 2 3], false)
+%!error <wrong type argument> eig ([1 2 ; 2 3], [1 2 ; 2 3], [1 2 ; 2 3])
+
 */
diff -r ba8a9d2934c7 -r fa85bd7065f3 libinterp/corefcn/xpow.cc
--- a/libinterp/corefcn/xpow.cc	Mon Jul 18 13:52:57 2016 +0200
+++ b/libinterp/corefcn/xpow.cc	Wed Jul 20 19:14:57 2016 +0200
@@ -123,7 +123,7 @@ xpow (double a, const Matrix& b)
       EIG b_eig (b);
 
       ComplexColumnVector lambda (b_eig.eigenvalues ());
-      ComplexMatrix Q (b_eig.eigenvectors ());
+      ComplexMatrix Q (b_eig.right_eigenvectors ());
 
       for (octave_idx_type i = 0; i < nr; i++)
         {
@@ -174,7 +174,7 @@ xpow (double a, const ComplexMatrix& b)
   try
     {
       ComplexColumnVector lambda (b_eig.eigenvalues ());
-      ComplexMatrix Q (b_eig.eigenvectors ());
+      ComplexMatrix Q (b_eig.right_eigenvectors ());
 
       for (octave_idx_type i = 0; i < nr; i++)
         {
@@ -263,7 +263,7 @@ precision, rcond = %g", rcond);
       try
         {
           ComplexColumnVector lambda (a_eig.eigenvalues ());
-          ComplexMatrix Q (a_eig.eigenvectors ());
+          ComplexMatrix Q (a_eig.right_eigenvectors ());
 
           for (octave_idx_type i = 0; i < nr; i++)
             lambda(i) = std::pow (lambda(i), b);
@@ -339,7 +339,7 @@ xpow (const Matrix& a, const Complex& b)
   try
     {
       ComplexColumnVector lambda (a_eig.eigenvalues ());
-      ComplexMatrix Q (a_eig.eigenvectors ());
+      ComplexMatrix Q (a_eig.right_eigenvectors ());
 
       for (octave_idx_type i = 0; i < nr; i++)
         lambda(i) = std::pow (lambda(i), b);
@@ -387,7 +387,7 @@ xpow (const Complex& a, const Matrix& b)
   try
     {
       ComplexColumnVector lambda (b_eig.eigenvalues ());
-      ComplexMatrix Q (b_eig.eigenvectors ());
+      ComplexMatrix Q (b_eig.right_eigenvectors ());
 
       for (octave_idx_type i = 0; i < nr; i++)
         {
@@ -435,7 +435,7 @@ xpow (const Complex& a, const ComplexMat
   try
     {
       ComplexColumnVector lambda (b_eig.eigenvalues ());
-      ComplexMatrix Q (b_eig.eigenvectors ());
+      ComplexMatrix Q (b_eig.right_eigenvectors ());
 
       for (octave_idx_type i = 0; i < nr; i++)
         {
@@ -524,7 +524,7 @@ precision, rcond = %g", rcond);
       try
         {
           ComplexColumnVector lambda (a_eig.eigenvalues ());
-          ComplexMatrix Q (a_eig.eigenvectors ());
+          ComplexMatrix Q (a_eig.right_eigenvectors ());
 
           for (octave_idx_type i = 0; i < nr; i++)
             lambda(i) = std::pow (lambda(i), b);
@@ -559,7 +559,7 @@ xpow (const ComplexMatrix& a, const Comp
   try
     {
       ComplexColumnVector lambda (a_eig.eigenvalues ());
-      ComplexMatrix Q (a_eig.eigenvectors ());
+      ComplexMatrix Q (a_eig.right_eigenvectors ());
 
       for (octave_idx_type i = 0; i < nr; i++)
         lambda(i) = std::pow (lambda(i), b);
@@ -1529,7 +1529,7 @@ xpow (float a, const FloatMatrix& b)
   try
     {
       FloatComplexColumnVector lambda (b_eig.eigenvalues ());
-      FloatComplexMatrix Q (b_eig.eigenvectors ());
+      FloatComplexMatrix Q (b_eig.right_eigenvectors ());
 
       for (octave_idx_type i = 0; i < nr; i++)
         {
@@ -1581,7 +1581,7 @@ xpow (float a, const FloatComplexMatrix&
   try
     {
       FloatComplexColumnVector lambda (b_eig.eigenvalues ());
-      FloatComplexMatrix Q (b_eig.eigenvectors ());
+      FloatComplexMatrix Q (b_eig.right_eigenvectors ());
 
       for (octave_idx_type i = 0; i < nr; i++)
         {
@@ -1670,7 +1670,7 @@ precision, rcond = %g", rcond);
       try
         {
           FloatComplexColumnVector lambda (a_eig.eigenvalues ());
-          FloatComplexMatrix Q (a_eig.eigenvectors ());
+          FloatComplexMatrix Q (a_eig.right_eigenvectors ());
 
           for (octave_idx_type i = 0; i < nr; i++)
             lambda(i) = std::pow (lambda(i), b);
@@ -1736,7 +1736,7 @@ xpow (const FloatMatrix& a, const FloatC
   try
     {
       FloatComplexColumnVector lambda (a_eig.eigenvalues ());
-      FloatComplexMatrix Q (a_eig.eigenvectors ());
+      FloatComplexMatrix Q (a_eig.right_eigenvectors ());
 
       for (octave_idx_type i = 0; i < nr; i++)
         lambda(i) = std::pow (lambda(i), b);
@@ -1784,7 +1784,7 @@ xpow (const FloatComplex& a, const Float
   try
     {
       FloatComplexColumnVector lambda (b_eig.eigenvalues ());
-      FloatComplexMatrix Q (b_eig.eigenvectors ());
+      FloatComplexMatrix Q (b_eig.right_eigenvectors ());
 
       for (octave_idx_type i = 0; i < nr; i++)
         {
@@ -1832,7 +1832,7 @@ xpow (const FloatComplex& a, const Float
   try
     {
       FloatComplexColumnVector lambda (b_eig.eigenvalues ());
-      FloatComplexMatrix Q (b_eig.eigenvectors ());
+      FloatComplexMatrix Q (b_eig.right_eigenvectors ());
 
       for (octave_idx_type i = 0; i < nr; i++)
         {
@@ -1921,7 +1921,7 @@ precision, rcond = %g", rcond);
       try
         {
           FloatComplexColumnVector lambda (a_eig.eigenvalues ());
-          FloatComplexMatrix Q (a_eig.eigenvectors ());
+          FloatComplexMatrix Q (a_eig.right_eigenvectors ());
 
           for (octave_idx_type i = 0; i < nr; i++)
             lambda(i) = std::pow (lambda(i), b);
@@ -1956,7 +1956,7 @@ xpow (const FloatComplexMatrix& a, const
   try
     {
       FloatComplexColumnVector lambda (a_eig.eigenvalues ());
-      FloatComplexMatrix Q (a_eig.eigenvectors ());
+      FloatComplexMatrix Q (a_eig.right_eigenvectors ());
 
       for (octave_idx_type i = 0; i < nr; i++)
         lambda(i) = std::pow (lambda(i), b);
